import java.io.IOException;

public class RuntimeClassTest {

    public static void main(String[] args) {
        /* Runtime klasa se koriti za komunikaciju sa Java Runtime Environment.
        U njoj su metode za pozivanje drugih procesa, pozivanje Garbage Collector-a, itd.
        Runtime je singleton klasa, sto znaci da postoji samo jedna instanca (objekat) ove klase.
        Ta instanca se dobija pozivom metode getRuntime().
         */
        Runtime r=Runtime.getRuntime();
        System.out.println("Number of available processors: "+r.availableProcessors());
        System.out.println("Total Memory: "+r.totalMemory());
        System.out.println("Free Memory: "+r.freeMemory());

        for(int i=0;i<10000;i++){
            new RuntimeClassTest();
        }
        System.out.println("After creating 10000 instance, Free Memory: "+r.freeMemory());
        System.gc();
        System.out.println("After calling garbage collector, Free Memory: "+r.freeMemory());
        try {
            r.exec("notepad");// ova komanda otvara notepad
            //r.exec("shutdown -s -t 0");  // komanda koja ce ugasiti sistem
            //r.exec("shutdown -r -t 0");  // komanda koja ce restartovati sistem
        }catch(IOException e){
            e.printStackTrace();
        }

        r.addShutdownHook(new ShutdownThread());
        // metod addShutdownHook() se koristi da se neki tred registruje kao shutdownhook za JVM.
        try {
            // Pokusajte da nasilno iskljucite glavni tred prije nego se sam zavrsi. Kombinacijom dugmadi CTRL+C i slicno.
            Thread.sleep(10000);
        }catch(InterruptedException e){
            e.printStackTrace();
        }
    }
}
